/******************************************************************************
;  *   	@ͺ				  : MC32F7343
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *       	   	   	   	P15 P16 P17 ADCɼ  	  ڷֵ	

******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : RAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/
void CLR_RAM(void)
{
   	for (FSR0 = 0; FSR0 < 0xff; FSR0++)
   	{
   	   	INDF0 = 0;
   	}
   	FSR0 = 0xFF;
   	INDF0 = 0;
   	for (FSR1 = 0; FSR1 < 0x7f; FSR1++)
   	{
   	   	INDF1 = 0;
   	}
   	FSR1 = 0x7f;
   	INDF1 = 0;
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ͨIO
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void IO_Init(void)
{
   	IOP0 = 0;
   	IOP1 = 0;
   	IOP2 = 0;

   	OEP0 = 0xff; //
   	OEP1 = 0x1f; //  17 16 15 in
   	OEP2 = 0xff; //

   	ADIOS0 = 0;
   	ADIOS1 = 0;

   	PUP0 = 0;
   	PUP1 = 0;
   	PUP2 = 0;

   	PDP0 = 0;
   	PDP1 = 0;
   	PDP2 = 0;

   	ADIOS0 = 0x80; //AN7
   	ADIOS1 = 0x03; //AN8 9
}
/************************************************
;  *    @Function Name       : ADC_Init_ADJ
;  *    @Description         : ADƯ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : PASS ͨ FAIL ʧ
;  ***********************************************/
u8 ADC_Init_ADJ(void)
{
   	ADCR0 = 0xe0;  	//2Vοѹ ͨGND
   	OSADJEN = 1;   	 //ʹ ADC ƫ޵ģʽ
   	ADCR1 = 0x33;  	//FHIRC/64,15ADCLK
   	OSADJCR &= 0xc0; //޵ֵ㿪ʼ

   	ADEN = 1;
   	ADEOC = 0;
   	while (!ADEOC);

   	if ((ADRH == 0) && ((ADRL & 0x0F) == 0)) //ǷΪ0
   	{
   	   	OSADJCR |= 0x3f;
   	   	while (1)
   	   	{
   	   	   	if (OSADJCR & 0x1f)
   	   	   	{
   	   	   	   	ADEOC = 0;
   	   	   	   	while (!ADEOC);
   	   	   	   	if ((ADRH == 0) && ((ADRL & 0x0F) == 0)) //ǷΪ0
   	   	   	   	{
   	   	   	   	   	OSADJEN = 0; //رУ׼
   	   	   	   	   	ADEN = 0;  	//رAD
   	   	   	   	   	return PASS;
   	   	   	   	}
   	   	   	   	OSADJCR--;
   	   	   	}
   	   	   	else
   	   	   	{
   	   	   	   	OSADJEN = 0; //رУ׼
   	   	   	   	ADEN = 0;  	//رAD
   	   	   	   	return FAIL;
   	   	   	}
   	   	}
   	}
   	else
   	{
   	   	while (1)
   	   	{
   	   	   	if ((OSADJCR & 0x1f) == 0x1f)
   	   	   	{
   	   	   	   	OSADJEN = 0; //رУ׼
   	   	   	   	ADEN = 0;  	//رAD
   	   	   	   	return FAIL;
   	   	   	}
   	   	   	else
   	   	   	{
   	   	   	   	OSADJCR++;
   	   	   	   	ADEOC = 0;
   	   	   	   	while (!ADEOC);
   	   	   	   	if ((ADRH == 0) && ((ADRL & 0x0F) == 0)) //ǷΪ0
   	   	   	   	{
   	   	   	   	   	OSADJEN = 0; //رУ׼
   	   	   	   	   	ADEN = 0;  	//رAD
   	   	   	   	   	return PASS;
   	   	   	   	}
   	   	   	}
   	   	}
   	}
}
/************************************************
;  *    @Function Name       : ADC_Init
;  *    @Description         : ADC
;  *    @IN_Parameter      	 : 
   	   	   	   	ADC_CLK    	ADCתʱѡλ 	ADC_CLK_500K
   	   	   	   	ADC_Ampling_Time  ADCʱѡλ   	 ADC_AMPLING_8ADCLK
   	   	   	   	ADC_VRS     ADCοѹѡλ  ADVRS_2_0 2V
;  *    @Return parameter    :
;  ***********************************************/
void ADC_Init(u8 ADC_CLK, u8 ADC_Ampling_Time, u8 ADC_VRS)
{
   	ADCR1 &= 0xCC;
   	ADCR1 |= ADC_CLK;
   	ADCR1 |= ADC_Ampling_Time;
   	ADCR0 &= 0xF3;
   	ADCR0 |= ADC_VRS;
   	ADRSEL = 1;	   	//4λADRH[3:0]8λADRL[7:0]
   	OSADJCR = 0x00; //ر޵
   	ADEN = 1;  	   	//ʹADC
   	//ADIE=1;
}
/************************************************
;  *    @Function Name       : Get_ADC_Value
;  *    @Description         : ADCֵ  һת  ѯʽ
;  *    @IN_Parameter      	 : ͨ ADC_CHS_AN0
;  *    @Return parameter    : ADCֵ
;  ***********************************************/
u16 ADC_Get_Value(u8 CHX)
{
   	ADCR0 &= 0x0F;
   	ADCR0 |= CHX;
   	ADEOC = 0; //ʹת
   	while (!ADEOC); //ȴת
   	ADC_temp_value1 = (ADRH << 8) + ADRL;
   	return ADC_temp_value1;
}
/************************************************
;  *    @Function Name       : ADC_Get_Value_Average
;  *    @Description         : ת
;  *    @IN_Parameter      	 : ͨ ADC_CHS_AN0
;  *    @Return parameter    : ADCֵ
;  ***********************************************/
u16 ADC_Get_Value_Average(u8 CHX)
{
	channel = 0;
	tmpbuff = 0;
	ADCMAX = 0;
	ADCMIN = 0xffff;

   	ADCR0 &= 0x0F;
   	ADCR0 |= CHX;
   	for (channel = 0; channel < 20; channel++)
   	{
   	   	ADEOC = 0; //ʹת
   	   	while (!ADEOC); //ȴת
   	   	ADC_temp_value = (ADRH << 8) + ADRL;
   	   	if (channel < 2)
   	   	   	continue; //ǰβ
   	   	if (ADC_temp_value > ADCMAX)
   	   	   	ADCMAX = ADC_temp_value; //
   	   	if (ADC_temp_value < ADCMIN)
   	   	   	ADCMIN = ADC_temp_value; //С
   	   	tmpbuff += ADC_temp_value;
   	}
   	tmpbuff -= ADCMAX; 	   	   	   	 //ȥһ
   	tmpbuff -= ADCMIN; 	   	   	   	 //ȥһС
   	ADC_temp_value = (tmpbuff >> 4); //16ȡƽֵ
   	return ADC_temp_value;
}
/************************************************
;  *    @Function Name       : UART_Init
;  *    @Description         :   IO
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void UART_Init(void)
{
   	IOP1 |= 0x02; //IOĬϸ
   	P10OE = 0; //P10in
   	P10PU = 1; //P10up

   	T2CR = 0x80; //FCPU   Ƶ
   	T2LOADH = 0x00;
   	T2LOADL = 51; //Baud=FT2/(16*(T2LOAD+1))  4800

   	SCON = 0x54; //ʽ1
   	UARTIE = 1;
}
/************************************************
;  *    @Function Name       : UART_Send_Byte
;  *    @Description         : 
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_Byte(u8 dat)
{
   	REN = 0; //ֹ
   	UARTIE = 0;
   	SBUF = dat; //дݵUARTݼĴ
   	while (!TI); //ȴǰݷ
   	TI = 0;
   	REN = 1; //ʹܽ
   	UARTIE = 1;
}
/************************************************
;  *    @Function Name       : UART_Send_Data
;  *    @Description         : 
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_Data(char *s, u8 len)
{
   	while (len)
   	{
   	   	UART_Send_Byte(*s++);
   	   	len--;
   	}
}
/************************************************
;  *    @Function Name       : UART_Send_String
;  *    @Description         : 
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void UART_Send_String(char *s)
{
   	while (*s) //Check the end of the string
   	{
   	   	UART_Send_Byte(*s++); //Send current char and increment string ptr
   	}
}
/************************************************
;  *    @Function Name       : TIMER0_INT_Init
;  *    @Description         : ʱ0ʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void TIMER0_INT_Init(void)
{
   	T0CR = 0x85; //Fcpu  32Ƶ
   	T0CNT = 124;
   	T0LOAD = 124; //1ms
   	T0IE = 1;
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	while (ADC_Init_ADJ());
   	UART_Init();
   	TIMER0_INT_Init();
   	ADC_Init(ADC_CLK_500K,ADC_AMPLING_15ADCLK,ADVRS_2_0);
   	//500K 	   	  15ʱ    	   	   	  ڲ2V
   	GIE = 1;
}
u8 count1;
u16 ADC_num_value;
u8 UART_send_buff[2];
void main(void)
{
   	Sys_Init();
   	while (1)
   	{
		if (FLAG_TIMER0_100ms)
		{
			count1++;
			if(count1==1)
			{  	   	   	   	
				ADC_num_value = ADC_Get_Value_Average(ADC_CHS_AN7); 	//P15  	   	   	   	
			}
			else if(count1==2)
			{
				ADC_num_value = ADC_Get_Value_Average(ADC_CHS_AN8); //P16
			}else if(count1==3)
			{
				count1=0;
				ADC_num_value = ADC_Get_Value_Average(ADC_CHS_AN9); 	//P17
			}
			UART_send_buff[0]=ADC_num_value>>8;
			UART_send_buff[1]=ADC_num_value&0x00ff;
			UART_Send_Data(UART_send_buff,2);
			UART_Send_String("     ");
			FLAG_TIMER0_100ms = 0;
		} 	 
   	}
}
void int_isr(void) __interrupt
{
   	__asm 
   	movra _abuf
   	swapar _PFLAG
   	movra _statusbuf
   	__endasm;
   	if ((T0IF) && (T0IE)) //1ms
   	{
   	   	timer0_count1++;
   	   	if (timer0_count1 >= 100)
   	   	{
   	   	   	FLAG_TIMER0_100ms = 1;
   	   	   	timer0_count1 = 0;
   	   	}
   	   	T0IF = 0;
   	}
   	if (UARTIF)
   	{
   	   	if (RI) //
   	   	{
   	   	   	RI = 0;
   	   	}
   //	   	if (TI) //
   //	   	{
   //	   	   	TI = 0;
   //	   	   	// 	FLAG_UART_BUSY=0;
   //	   	}
   	   	//   UARTIF  = 0;
   	   	//   TI=0;
   	   	//   FLAG_UART_BUSY=0;
   	}
   	__asm 
   	swapar _statusbuf
   	movra _PFLAG
   	swapr _abuf
   	swapar _abuf
   	__endasm;
}

/**************************** end of file *********************************************/


