/******************************************************************************
;  *   	@ͺ				  : MC32F7343
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------  ---------------------------------
;  *   				ʱʹȫֱ	               	
******************************************************************************/

#ifndef USER
#define USER

#include "MC32F7343.h"

#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long int
#define uint8_t  unsigned char
#define uint16_t unsigned int
#define uint32_t unsigned long int

#define PASS 0
#define FAIL 1

#define ADC_CHS_AN0		0x00
#define ADC_CHS_AN1		0x10
#define ADC_CHS_AN2		0x20
#define ADC_CHS_AN3		0x30
#define ADC_CHS_AN4		0x40
#define ADC_CHS_AN5		0x50
#define ADC_CHS_AN6		0x60
#define ADC_CHS_AN7		0x70
#define ADC_CHS_AN8		0x80
#define ADC_CHS_AN9		0x90
#define ADC_CHS_AN10	0xA0
#define ADC_CHS_AN11	0xB0
#define ADC_CHS_AN12	0xC0
#define ADC_CHS_AN13	0xD0
#define ADC_CHS_ANVDD_4	0xF0

#define ADVRS_2_0	0			//2V
#define ADVRS_VDD	0x0C		//VDD

#define ADC_AMPLING_4ADCLK	0x01
#define ADC_AMPLING_8ADCLK	0x02
#define ADC_AMPLING_15ADCLK	0x03

#define ADC_CLK_2M		0
#define ADC_CLK_1M		0x10
#define ADC_CLK_500K	0x20
#define ADC_CLK_250K	0x30


u8 abuf;
u8 statusbuf;
u16 timer0_count1;
u16 ADC_temp_value1;

u8 channel;
unsigned long int tmpbuff;
u16 ADCMAX;
u16 ADCMIN;
u16 ADC_temp_value;

void CLR_RAM(void);
void IO_Init(void);
u8 ADC_Init_ADJ(void);
void ADC_Init(u8 ADC_CLK,u8 ADC_Ampling_Time,u8 ADC_VRS);
u16 Get_ADC_Value(u8 CHX);
u16 ADC_Get_Value_Average(u8 CHX);
void UART_Init(void);
void UART_Send_Byte(u8 dat);
void UART_Send_Data(char *s, u8 len);
void UART_Send_String(char *s);
void TIMER0_INT_Init(void);
void Sys_Init(void);


//============Define  Flag=================
typedef union {
   	unsigned char byte;
   	struct
   	{
   	   	u8 bit0 : 1;
   	   	u8 bit1 : 1;
   	   	u8 bit2 : 1;
   	   	u8 bit3 : 1;
   	   	u8 bit4 : 1;
   	   	u8 bit5 : 1;
   	   	u8 bit6 : 1;
   	   	u8 bit7 : 1;
   	} bits;
}bit_flag;
volatile bit_flag flag1;

#define  	FLAG_TIMER0_100ms  	flag1.bits.bit0	 
#define  	FLAG_UART_BUSY  		flag1.bits.bit1

#endif

/**************************** end of file *********************************************/

