/******************************************************************************
;  *   	@ͺ				  : MC32F7343
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *       	   	   	   	  ϵEEַд;ٶȡж
   	   	   	   	   	   	  ȫȷP23Dߣ  	       	   	   	   	   	   	   	   	   	   	
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : RAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/ 
void CLR_RAM(void)
{
   	for(FSR0=0;FSR0<0xff;FSR0++) 
   	{
   	   	INDF0=0;
   	}
   	FSR0=0xFF;
   	INDF0=0;
   	for(FSR1=0;FSR1<0x7f;FSR1++) 
   	{
   	   	INDF1=0;
   	}
   	FSR1=0x7f;
   	INDF1=0; 
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ͨIO
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/   
void IO_Init(void)
{
   	IOP0=0;
   	IOP1=0;
   	IOP2=0;
   	
   	OEP0=0xff; 	   	//P0  out
   	OEP1=0xff; 	   	//P1  out
   	OEP2=0xff; 	   	//P2  out
   	
   	ADIOS0=0;
   	ADIOS1=0;
   	
   	PUP0=0;
   	PUP1=0;        	   	  
   	PUP2=0;    	   	   	
   	
   	PDP0=0;
   	PDP1=0;
   	PDP2=0;
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	GIE  = 1;        
}
/************************************************
;  *    @Function Name       : EEPROM_Write_Byte
;  *    @Description         : ڲEEPROMдһֽ
;  *    @IN_Parameter      	 : ַ  
;  *    @Return parameter    :
;  ***********************************************/  
void EEPROM_Write_Byte(u8 addr,u8 data)
{
   	EECR=0;	   	//EETRIG
   	EEAR=addr;
   	EEDR=data;
   	GIE=0;
    ClrWdt();  	   	//忴Ź
   	EEMASK=0x5A;
   	EEMASK=0xA5;   	   	//
   	EECR=0xC0; 	   	   	//EEPROMд  дݲ
   	Nop();
   	GIE=1;
}
/************************************************
;  *    @Function Name       : EEPROM_Read_Byte
;  *    @Description         : ڲEEPROMһֽ
;  *    @IN_Parameter      	 : Addr  ַ
;  *    @Return parameter    : 
;  ***********************************************/  
u8 EEPROM_Read_Byte(u8 addr)
{
   	EECR=0;	   	//EETRIG
   	EEAR=addr;
   	GIE=0;
   	EEMASK=0x5A;
   	EEMASK=0xA5;   	   	//
   	EECR=0x80; 	   	   	//EEPROMд  ݲ
   	Nop();
   	GIE=1;
   	return EEDR;
}
/************************************************
;  *    @Function Name       : EEPROM_Write_Data
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void EEPROM_Write_Data(u8 addr,u8 *data,u8 len)
{
   	while (len)
   	{
   	   	EEPROM_Write_Byte(addr++,*data++);
   	   	len--;
   	}
}
const u8 EEPROM_test_num[10]={0,1,2,3,4,5,6,7,8,9};
u8 EEPROM_test_buff[10];
u8 count1;
void main(void)
{
   	Sys_Init();

   	EEPROM_Write_Data(0,EEPROM_test_num,10);   	   	//д
   	for(count1=0;count1<10;count1++)
   	{
   	   	EEPROM_test_buff[count1]=EEPROM_Read_Byte(count1); 	   	//ȡ
   	}
   	if((EEPROM_test_buff[0]==0)&&(EEPROM_test_buff[1]==1)&&(EEPROM_test_buff[2]==2)
   	&&(EEPROM_test_buff[3]==3)&&(EEPROM_test_buff[4]==4)&&(EEPROM_test_buff[5]==5)
   	&&(EEPROM_test_buff[6]==6)&&(EEPROM_test_buff[7]==7)&&(EEPROM_test_buff[8]==8)
   	&&(EEPROM_test_buff[9]==9))
   	{
   	   	P23D=1;
   	}else 
    {
   	   	P23D=0;
    }
   	while(1)
   	{  	 

   	}
}

void int_isr(void)__interrupt
{
__asm
   	movra   _abuf
   	swapar  _PFLAG
   	movra   _statusbuf
__endasm;

__asm
   	swapar  _statusbuf
   	movra   _PFLAG
   	swapr   _abuf
   	swapar  _abuf
__endasm;
}


/**************************** end of file *********************************************/







