/******************************************************************************
;  *   	@ͺ				  : MC32F7343
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *      				дݣڶ
						ȷP00
						֮
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : RAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/ 
void CLR_RAM(void)
{
   	for(FSR0=0;FSR0<0xff;FSR0++) 
   	{
   	   	INDF0=0;
   	}
   	FSR0=0xFF;
   	INDF0=0;
   	for(FSR1=0;FSR1<0x7f;FSR1++) 
   	{
   	   	INDF1=0;
   	}
   	FSR1=0x7f;
   	INDF1=0; 
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ͨIO
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/   
void IO_Init(void)
{
   	IOP0=0;
   	IOP1=0;
   	IOP2=0;
   	
   	OEP0=0xff; 	   	//P0  out
   	OEP1=0xff; 	   	//P1  out
   	OEP2=0xff; 	   	//P2  out 
   	
   	ADIOS0=0;
   	ADIOS1=0;
   	
   	PUP0=0;
   	PUP1=0;        	   	  
   	PUP2=0x00; 	   	   	   	   	
   	
   	PDP0=0;
   	PDP1=0;
   	PDP2=0;
}
/************************************************
;  *    @Function Name       : IIC_Init
;  *    @Description         : 
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/ 
void IIC_Init(void)
{
   	IICCR=0x01; //100kbps,ж      	  
   	IICIE=1;
   	IICEN=1;   	   	   	       	       	    
}
/************************************************
;  *    @Function Name       : IIC_Start
;  *    @Description         : IICʼź
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void IIC_Start(u8 R_Slave_addr,u8 CMD)
{
   	IICSTR=1;
   	while(FLAG_IIC_DONE==0);
   	FLAG_IIC_DONE=0;
   	if(CMD)
   	{
   	   	IICDR=R_Slave_addr+1;
   	}else
   	{
   	   	IICDR=R_Slave_addr;
   	}      	   	
   	IICWR=1;
   	while(FLAG_IIC_DONE==0);
   	FLAG_IIC_DONE=0;       	   	
}
/************************************************
;  *    @Function Name       : IIC_Stop
;  *    @Description         : IICʼź
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/ 
void IIC_Stop(void)
{
   	IICSTP=1;
   	while(FLAG_IIC_DONE==0);
   	FLAG_IIC_DONE=0;
}
/************************************************
;  *    @Function Name       : IIC_Write_Byte
;  *    @Description         : дһ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/
void IIC_Write_Byte(u8 data)
{
   	if(RACK==0)
   	{
   	   	IICDR=data;
   	   	IICWR=1;
   	   	while(FLAG_IIC_DONE==0);
   	   	FLAG_IIC_DONE=0;
   	}  	   	
}
/************************************************
;  *    @Function Name       : IIC_Read_Byte
;  *    @Description         : һ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/
u8 IIC_Read_Byte(void)
{
   	if(RACK==0)
   	{
   	   	IICRD=1;
   	   	while(FLAG_IIC_DONE==0);
   	   	FLAG_IIC_DONE=0;
   	   	temp=IICDR;
   	   	SACK=1;    	
   	   	IICACK=1;
   	   	while(FLAG_IIC_DONE==0);
   	   	FLAG_IIC_DONE=0;
   	   	return temp;
   	}
}
/************************************************
;  *    @Function Name       : AT24C02_Write_Byte
;  *    @Description         : дһ
;  *    @IN_Parameter      	 : ֵַ 
;  *    @Return parameter    : 
;  ***********************************************/
void AT24C02_Write_Byte(u8 addr,u8 data)
{
   	IIC_Start(EE_24C02_ADDR,IIC_WRITE_CMD);
   	IIC_Write_Byte(addr);
   	IIC_Write_Byte(data);  	   	
   	IIC_Stop();
}
/************************************************
;  *    @Function Name       : AT24C02_Read_Byte
;  *    @Description         : һ
;  *    @IN_Parameter      	 : ֵַ 
;  *    @Return parameter    : 
;  ***********************************************/
u8 AT24C02_Read_Byte(u8 addr)
{
   	
   	IIC_Start(EE_24C02_ADDR,IIC_WRITE_CMD);
   	IIC_Write_Byte(addr);
   	IIC_Start(EE_24C02_ADDR,IIC_READ_CMD);
   	num_value=IIC_Read_Byte();  
   	IIC_Stop();
   	return num_value;
}
/************************************************
;  *    @Function Name       : AT24C02_Write_Len_Byte
;  *    @Description         : д
;  *    @IN_Parameter      	 : ֵַ  
;  *    @Return parameter    : 
;  ***********************************************/
void AT24C02_Write_Len_Byte(u8 addr,u8 *data,u8 len)
{
   	while(len)
   	{
   	   	AT24C02_Write_Byte(addr++,*data++);
   	   	len--;
   	   	Delay(2000);
   	}
}
/************************************************
;  *    @Function Name       : AT24C02_Read_Len_Byte
;  *    @Description         : 
;  *    @IN_Parameter      	 : ֵַ  
;  *    @Return parameter    : 
;  ***********************************************/
void AT24C02_Read_Len_Byte(u8 addr,u8 *data,u8 len)
{
   	while(len)
   	{
   	   	*data=AT24C02_Read_Byte(addr++);
   	   	data++;
   	   	len--;
   	}
}
/************************************************
;  *    @Function Name       : Delay
;  *    @Description         : ׼ʱ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void Delay(u16 num)
{
   	while(num)
   	{
   	   	Nop();
   	   	Nop();
   	   	Nop();
   	   	Nop();
   	   	num--;
   	}
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	IIC_Init();
   	GIE  = 1;        
}
/************************************************
;  *    @Function Name       : Data_Comparison
;  *    @Description         : ݱȽ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
u8 Data_Comparison(u8 *data1,u8 *data2,u8 len)
{
   	while(len)
   	{
   	   	if(*data1!=*data2) 	return FAIL;
   	   	len--;
   	   	data1++;
   	   	data2++;
   	}
   	return PASS;
}
void main(void)
{
   	Sys_Init();
   	AT24C02_Write_Len_Byte(0,IIC_test_buff_data,IIC_DATA_LEN);
   	Delay(1000);
   	AT24C02_Read_Len_Byte(0,IIC_test_buff,IIC_DATA_LEN);
   	while(1)
   	{  	 
   	   	if(Data_Comparison(IIC_test_buff_data,IIC_test_buff,IIC_DATA_LEN))
   	   	   	P00D=0;
   	   	else P00D=1;
   	}
}

void int_isr(void)__interrupt
{
__asm
   	movra   _abuf
   	swapar  _PFLAG
   	movra   _statusbuf
__endasm;  	
   	if(IICIF)
   	{
   	   	IICIF  = 0;
   	   	FLAG_IIC_DONE=1;
   	}
__asm
   	swapar  _statusbuf
   	movra   _PFLAG
   	swapr   _abuf
   	swapar  _abuf
__endasm;
}


/**************************** end of file *********************************************/





