/******************************************************************************
;  *   	@ͺ				  : MC32F7343
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------  ---------------------------------
;  *   				ʱʹȫֱ	               	
******************************************************************************/

#ifndef USER
#define USER

#include "MC32F7343.h"

#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long int
#define uint8_t  unsigned char
#define uint16_t unsigned int
#define uint32_t unsigned long int

#define IIC_WRITE_CMD  	0
#define IIC_READ_CMD   	1
#define EE_24C02_ADDR 0xA0
#define IIC_DATA_LEN   	10
#define PASS   	0
#define FAIL   	1

u8 abuf;
u8 statusbuf;
u8 temp;
u8 num_value;
const u8 IIC_test_buff_data[IIC_DATA_LEN]={1,2,3,4,5,6,7,8,9,10};
u8 IIC_test_buff[IIC_DATA_LEN];

void CLR_RAM(void);
void IO_Init(void);
void INT_Init(void);
void IIC_Init(void);
void IIC_Start(u8 R_Slave_addr,u8 CMD);
void IIC_Stop(void);
void IIC_Write_Byte(u8 data);
u8 IIC_Read_Byte(void);
void AT24C02_Write_Byte(u8 addr,u8 data);
u8 AT24C02_Read_Byte(u8 addr);
void AT24C02_Write_Len_Byte(u8 addr,u8 *data,u8 len);
void AT24C02_Read_Len_Byte(u8 addr,u8 *data,u8 len);
void Delay(u16 num);
u8 Data_Comparison(u8 *data1,u8 *data2,u8 len);
void Sys_Init(void);


//============Define  Flag=================
typedef union {
   	unsigned char byte;
   	struct
   	{
   	   	u8 bit0 : 1;
   	   	u8 bit1 : 1;
   	   	u8 bit2 : 1;
   	   	u8 bit3 : 1;
   	   	u8 bit4 : 1;
   	   	u8 bit5 : 1;
   	   	u8 bit6 : 1;
   	   	u8 bit7 : 1;
   	} bits;
}bit_flag;
volatile bit_flag flag1;

#define    	FLAG_IIC_DONE  	flag1.bits.bit0	 


#endif

/**************************** end of file *********************************************/

