/******************************************************************************
;  *   	@ͺ				  : MC32F7343
;  *   	@             : 2021.08.04
;  *   	@˾/			  : SINOMCU-FAE
;  *   	@΢֧       : 2048615934
;  *   	@΢           : http://www.sinomcu.com/
;  *   	@Ȩ                 : 2021 SINOMCU˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *       	   	   	   	T0 P23 1msת
   	   	   	   	   	   	T1 PWM1(P14) 10K 50% 
   	   	   	   	   	   	T2 P07 10msת  	 
   	   	   	   	   	   	2S P17½ػ    	   	   	   	   	   	   	   	   	   	   	
******************************************************************************/

#include "user.h"

/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : RAM
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    : 
;  ***********************************************/ 
void CLR_RAM(void)
{
   	for(FSR0=0;FSR0<0xff;FSR0++) 
   	{
   	   	INDF0=0;
   	}
   	FSR0=0xFF;
   	INDF0=0;
   	for(FSR1=0;FSR1<0x7f;FSR1++) 
   	{
   	   	INDF1=0;
   	}
   	FSR1=0x7f;
   	INDF1=0; 
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ͨIO
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/   
void IO_Init(void)
{
   	IOP0=0;
   	IOP1=0;
   	IOP2=0;
   	
   	OEP0=0xff; 	   	//P0  out
   	OEP1=0x7f; 	   	//P1  out  P17 in
   	OEP2=0xff; 	   	//P2  out
   	
   	ADIOS0=0;
   	ADIOS1=0;
   	
   	PUP0=0;
   	PUP1=0x80;     	   	 //P17 up  	   
   	PUP2=0;    	   	   	
   	
   	PDP0=0;
   	PDP1=0;
   	PDP2=0;
}
/************************************************
;  *    @Function Name       : TIMER0_INT_Init
;  *    @Description         : ʱ0ʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void TIMER0_INT_Init(void)
{
    T0CR=0x84; 	   	//Fcpu  16Ƶ
    T0CNT=124;
    T0LOAD=124;	   	   	//1ms
    T0IE=1;    	    
}
/************************************************
;  *    @Function Name       : TIMER1_PWM_Init
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER1_PWM_Init(void)
{
    T1CR=0xc8;     	   	//ʹPWM1  Fhosc 16M  Ƶ
    T1CNTH=0x06;
    T1CNTL=0x3f;
    T1LOADH=0x06;
    T1LOADL=0x3f;  	   	//10k
    T1DATAH=0x03;
    T1DATAL=0x1f;   
}
/************************************************
;  *    @Function Name       : IO_Config
;  *    @Description         : ͨIO
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void TIMER2_INT_Init(void)
{
   	T2CR=0x85; 	   	//Fcpu 32Ƶ
   	T2CNTH=0x04;
   	T2CNTL=0xE1;
   	T2LOADH=0x04;
   	T2LOADL=0xE1;  	   	   	//10ms
   	T2IE=1;    	    
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter      	 : 
;  *    @Return parameter    :
;  ***********************************************/  
void Sys_Init(void)
{
   	GIE = 0;
   	CLR_RAM();
   	IO_Init();
   	TIMER0_INT_Init();
   	TIMER1_PWM_Init();
   	TIMER2_INT_Init();
   	GIE  = 1;        
}
void main(void)
{
   	Sys_Init();

    KBCR7=1;   	   	   	//P17ж
   	while(1)
   	{  	 
   	   	 if(FLAG_TIMER1_2000ms)
   	   	 {
   	   	   	FLAG_TIMER1_2000ms=0;
   	   	   	ADEN=0;	   	//ر裨ûѡ
   	   	   	T1CR&=0xBF;
   	   	   	T1EN=0;
   	   	   	P14D=0;
   	   	   	P23D=0;
   	   	   	P07D=0;
   	   	   	//߹ر
   	   	   	GIE = 0;
   	   	   	KBIF=0;
   	   	   	KBIE = 1;
   	   	   	Nop();
   	   	   	Nop();
   	   	   	Stop();
   	   	   	Nop();
   	   	   	Nop();
   	   	   	KBIE = 0;
   	   	   	KBIF = 0;
   	   	   	GIE = 1;
   	   	   	//ѻԭ ûѡ
   	   	   	ADEN=1;
   	   	   	T1CR|=0x40;
   	   	   	T1EN=1;
   	   	 }
   	}
}

void int_isr(void)__interrupt
{
__asm
   	movra   _abuf
   	swapar  _PFLAG
   	movra   _statusbuf
__endasm;
   	if((T0IF)&&(T0IE)) 	   	   	//1ms
   	{      	       	
   	   	T0IF=0;
   	   	P23D=!P23D;
   	}
   	if((T2IF)&&(T2IE)) 	   	//10ms
   	{
   	   	T2IF  = 0; 	
   	   	P07D=!P07D;
   	   	timer2_count1++;
   	   	if(timer2_count1>=200)
   	   	{
   	   	   	FLAG_TIMER1_2000ms=1;
   	   	   	timer2_count1=0;
   	   	}
   	}

__asm
   	swapar  _statusbuf
   	movra   _PFLAG
   	swapr   _abuf
   	swapar  _abuf
__endasm;
}


/**************************** end of file *********************************************/







